;not tested!

include qlib.inc

include file.inc
include string.inc
include key.inc

.data

filei dd 0  ;file names
fileo dd 0

byp dd 0
bufsiz dd 0
rlesiz dd 0

header db 'FLK',26
  hxres dw 0
  hyres dw 0
  bpp db 0
  total dw 1    ;total (always 1 for PICs)
  frame2 dd 0   ;frame 2 (ignore)
  spd dd 0      ;speed (ignore)
  flgs db 0     ;Bit 0:delta to 2nd frame included (always 0 in PICs)
  db 4 dup (0)  ;reserved

  bi dword 0  ;input 1 frame n
  bo dword 0   ;output (compressed)

xres dd 0
xresb dd 0   ;x*bypp
yres dd 0
pal_head db 4
 dd 768
num dw 0  ;current number
frm dw 0    ;current frame
maxfrm word 0   ;MAX frame # allowed
fo word 0  ;file out handle

include loadbmp.asm

.code

include num2str.asm
;Palette            ;4
include rle.asm     ;2
include copy.asm    ;1
include invert.asm

;code
main proc
  ;buffers

  invoke print,"BMP2PIC v1.01 by Peter Quiring\n"

  jmp @f
badram:
  mov eax,"Error:Out of RAM\n"
error1:
  callp print,eax
  callp exit,0
badarg:
  mov eax,"USAGE: BMP2PIC infile outfile\n"
  jmp error1
badfile:
  mov eax,"Error:file I/O\n"
  jmp error1
@@:

  .if _argc!=3
    jmp badarg
  .endif

  mov ebx,_argv
  mov eax,[ebx+1*4]
  mov filei,eax
  mov eax,[ebx+2*4]
  mov fileo,eax

  invoke strlen,filei
  cmp eax,4
  jnz badarg

;all setup
  invoke creat,fileo,0
  cmp eax,ERROR
  jz badfile
  mov fo,ax

  callp get_bmp  ;1st call will only set bufsiz according to 1st file
  callp malloc,bufsiz
  .if eax==ERROR
    jmp badram
  .endif
  mov bi,eax
  mov eax,bufsiz  
  shl eax,1  ;*2  ;some frames may get larger (rare)
  invoke malloc,eax
  .if eax==ERROR
    jmp badram
  .endif
  mov bo,eax

  movzx eax,bmp_x
  mov hxres,ax
  mov xres,eax
  movzx ebx,bmp_y
  mov hyres,bx
  mov yres,ebx
  .if bmp_bpp==8
    mov bpp,8
    mov byp,1
    mov xresb,eax
    mul ebx
    mov bufsiz,eax
  .else
    mov bpp,24
    mov byp,3
    imul eax,3
    mov xresb,eax
    mul ebx
    mov bufsiz,eax
  .endif

  callp get_bmp

  invoke write,fo,offset header,24    ;no fixup needed

  callp comp_bmp
  call end_it
  jmp @b
main endp

get_bmp proc
  call getch
  .if al==27
    call end_it
  .endif

  ;make file=frm #
@@:
  callp load_bmp,filei,bi
  .if eax==ERROR
    callp print,"File not found"
    callp close,fo
    callp unlink,fileo
    callp exit,0
  .endif
  ret
get_bmp endp

comp_bmp proc
  call do_pal
  callp rle_compress,bi,bo
  .if (eax>bufsiz)
    jmp do_copy
  .endif
  mov bl,2
  jmp do_it
do_copy:
  callp copy,bi,bo
  mov bl,3
do_it:
  mov ecx,eax  ;preserve eax until...
  callp print,"\n"
  callp print,filei
  .if bl==2
    callp print,"(RLE)"
  .else
    callp print,"(COPY)"
  .endif
  callp write,fo,bo,ecx           ;...here
  callp printf," = %d\n",ecx

  ret
comp_bmp endp

end_it proc  ;finish up stuff & quit

  mov ax,frm
  mov total,ax
  add frame2,24  ;to include header!
  invoke lseek,fo,0,0
  invoke write,fo,offset header,24
  
  invoke close,fo

  callp exit,0
end_it endp

paldone db 0  ;flag

do_pal proc
  .if bpp==8
    invoke write,fo,offset pal_head,5
    invoke write,fo,offset bmppal,768
    callp printf," (PAL) = (768+5)\n"
  .endif
  ret
do_pal endp

end
