include qlib.inc  ;setup
include file.inc
include string.inc
include private.inc

.data
  ;used by _sprintf_
tempstr db 34 dup(?)  ;max =33 for dword binary!

.code
print proc,off:dword
  callp strlen,off
  or eax,eax
  jnz @f
  ret
@@:
  pushad
  mov ecx,eax
  mov esi,off
@@:
  lodsb
  .if al==13
    lodsb
    .if !al
      jmp cont
    .endif
    jmp @b
  .elseif al==10
    inc ecx  ;CR + LF
    jmp @b
  .elseif al
    jmp @b
  .endif
cont:
  sub esp,ecx
  mov esi,off
  mov edi,esp
@@:
  lodsb
  .if al==13
    stosb
    lodsb    ;it may be 10
    .if !al
      jmp done
    .endif
    stosb
    jmp @b
  .elseif al==10
    mov al,13
    stosb
    mov al,10
    stosb
    jmp @b
  .elseif al
    stosb
    jmp @b
  .endif
done:
  mov eax,esp
  callp write,1,eax,ecx  ;handle , offset , size
  add esp,ecx
  popad
  xor eax,eax
  ret
print endp

putch proc uses ebx,char:byte
  lea ebx,char
  .if char==10
    mov char,13
    callp write,1,1,ebx
    mov char,10
    callp write,1,1,ebx
  .else
    callp write,1,1,ebx
  .endif
  ret
putch endp

printxy proc,x:word,y:word,off:dword
  pushad
  callp gotoxy,x,y
  callp print,off
  popad
  xor eax,eax
  ret
printxy endp

.data
align 4
  _bak dd ?
  _width dd ?
  _pos db ?   ;flag  use positive sign on signed #'s
  _zero db ?  ;flag  do not remove leading zeros
  _mod db ?
  _pad dd ?
  _typ db ?

.code
decode_per proc uses ecx
  ; in : esi=string (right after %)
  ;    : ebx=varargs
  ; out : eax=# bytes needed
  ;     : _typ=char (c,s,w,b,d)
  ;     : _mod=char (nil,H,B,S)
  ;     : _width=byte (0=none,99=max)
  ;     : _zero = T/F
  ;     : _pos = T/F
  mov _pos,0
  mov _zero,0
  mov _width,0
  mov _mod,0
  mov _bak,esi
@@:
  lodsb
gotit:
  .if al=='0'
    .if _zero
      jmp bad
    .endif
    inc _zero
    jmp @b
  .elseif (al=='+')
    .if _pos
      jmp bad
    .endif
    inc _pos
    jmp @b
  .elseif (al>='1') && (al<='9')
    .if _width
      jmp bad
    .endif
    xor ecx,ecx
    mov cl,al
    sub cl,'0'
    xor ah,ah
    lodsb
    .if (al>='0') && (al<='9')
      imul cx,10
      sub al,'0'
      add cx,ax
      mov _width,ecx
      jmp @b
    .else
      mov _width,ecx
      jmp gotit
    .endif
  .elseif (al=='H') || (al=='S') || (al=='B')
    .if _mod
      jmp bad
    .endif
    mov _mod,al
    jmp @b
  .elseif al=='s'
    .if (_mod) || (_zero)
      jmp bad
    .endif
    mov _typ,al
    mov eax,[ebx]
    callp strlen,eax
  .elseif al=='b'
    mov _typ,al
    mov al,_mod
    .if al=='H'
      mov eax,2
    .elseif al=='B'
      mov eax,8
    .elseif al=='S'
      mov eax,4
    .else
      mov eax,3
    .endif
  .elseif al=='w'
    mov _typ,al
    mov al,_mod
    .if al=='H'
      mov eax,4
    .elseif al=='B'
      mov eax,16
    .elseif al=='S'
      mov eax,6
    .else
      mov eax,5
    .endif
  .elseif al=='d'
    mov _typ,al
    mov al,_mod
    .if al=='H'
      mov eax,8
    .elseif al=='B'
      mov eax,32
    .elseif al=='S'
      mov eax,11
    .else
      mov eax,10
    .endif
  .elseif al=='c'
    .if _mod
      jmp bad
    .endif
    mov _typ,al
    mov eax,1
  .else
    jmp bad
  .endif
  add ebx,4
  .if eax < _width
    mov ecx,_width
    mov _pad,ecx
    sub _pad,eax
    mov eax,ecx
  .endif
  ret
bad:
  mov esi,_bak
  mov _typ,0
  xor eax,eax
  ret
decode_per endp

_printf_siz_ proc
  ;calculate maximum RAM required for string when all % expanded.
  ; in : esi = str , ebx = vararg
  ; out : eax = max size needed
  local siz:dword
  mov siz,0
@@:
  cmp byte ptr[esi],0
  jz @f
  cmp byte ptr[esi],'%'
  jz @@per
  inc siz
  inc esi
  jmp @b
@@per:
  inc esi
  cmp byte ptr[esi],'%'
  jnz @@per2
  inc esi
  inc siz
  jmp @b
@@per2:
  call decode_per
  .if !eax
    inc siz ;for the % (w/ error)
  .elseif
    add siz,eax
  .endif
  jmp @b
@@:
  inc siz ;for the 0
  mov eax,siz
  ret
_printf_siz_ endp                                    

align 4
printf proc,str1:dword,argv:vararg
  local siz:dword
  pushad
  mov ebx,ebp
  add ebx,12 ;now pts to varargs : locals(4),EBP(4),ret(4),str1(4),vararg
  mov esi,str1
  call _printf_siz_
  mov ebx,ebp
  add ebx,12
  mov esi,str1
  mov siz,eax
  sub esp,eax
  mov edi,esp
  call _sprintf_
  callp print,esp   ;esp will be pushed before dec by 4 (not on 8086)
  add esp,siz
  popad
  xor eax,eax
  ret
printf endp

sprintf proc,dest:dword,src:dword,argv:vararg
  pushad
  mov ebx,ebp
  add ebx,16     ;ebx=>vararg's : EBP , ret , dest , src , vararg
  mov esi,src
  mov edi,dest
@@:
  call _sprintf_
  popad
  xor eax,eax
  ret
sprintf endp

;prints into string (used by printf&sprintf)
;returns when a)hit end of string b)hit %s
_sprintf_ proc  ;ebx=varargs esi=src edi=dest
  ; NO LOCALS ALLOWED HERE!!!
  ;scans C type string from src => dest
  ; % [+][0][width][[S,H,B](b,w,d)],[c],[%],[s]
  ; +=use + when printing signed #'s
  ; 0=keep all leading zeros (MAX:byte=3  word=5  dword=10)
  ; S=signed decimal \
  ; H=hex output      = default is
  ; B=binary output  /  decimal
  ; (b=byte,w=word,d=dword,c=char,%=%)
  ; prefixes ignored with char
  push ebp
  mov ebp,ebx
@@top:
  mov al,[esi]
  cmp al,0
  jz __end
  cmp al,'%'
  jz @@per
@@per1:  
  movsb
  jmp @@top
@@per: ; % is use
  inc esi
  mov al,[esi]
  cmp al,'%'
  jz @@per1    ;2 % = 1 %
  mov ebx,ebp
  call decode_per
  mov bl,_mod
  mov al,_typ
  cmp al,0
  jz __end

  cmp al,'b'
  jz @@perb
  cmp al,'w'
  jz @@perw
  cmp al,'d'
  jz @@perd
  cmp al,'c'
  jz @@perc
;must be %s
  .if _width && _pad
    mov al,32
    mov ecx,_pad
    rep stosb
  .endif
  callp strcpy,edi,[ebp]
  callp strlen,[ebp]
  add edi,eax
  add ebp,4
  jmp @@top
@@perb:
  cmp bl,'S'
  jz @@bs  ;byte signed
  cmp bl,'H'
  jz @@bh  ;byte signed
  cmp bl,'B'
  jz @@bb  ;byte signed
;normal
  callp num2str_b,[ebp],offset tempstr
  jmp addstr
@@bb:
  callp num2str_bb,[ebp],offset tempstr
  jmp addstr
@@bs:
  callp num2str_bs,[ebp],offset tempstr
  jmp addstr
@@bh:
  callp num2str_bh,[ebp],offset tempstr
  jmp addstr  
@@perw:
  cmp bl,'S'
  jz @@ws
  cmp bl,'H'
  jz @@wh
  cmp bl,'B'
  jz @@wb
;norm
  callp num2str_w,word ptr[ebp],offset tempstr
  jmp addstr
@@wb:
  callp num2str_wb,word ptr[ebp],offset tempstr
  jmp addstr
@@ws:
  callp num2str_ws,word ptr[ebp],offset tempstr
  jmp addstr
@@wh:
  callp num2str_wh,word ptr[ebp],offset tempstr
  jmp addstr
@@perd:
  cmp bl,'S'
  jz @@ds
  cmp bl,'H'
  jz @@dh
  cmp bl,'B'
  jz @@db
;norm
  callp num2str_d,[ebp],offset tempstr
  jmp addstr
@@db:
  callp num2str_db,[ebp],offset tempstr
  jmp addstr
@@ds:
  callp num2str_ds,[ebp],offset tempstr
  jmp addstr
@@dh:
  callp num2str_dh,[ebp],offset tempstr
  jmp addstr
@@perc:
  mov al,[ebp]
  mov [edi],al
  inc edi
  add ebp,4    ;no byte pushes possible
  jmp @@top
__end:
  mov byte ptr[edi],0
  pop ebp
  ret
addstr:
  add ebp,4      ;move to next var.
  ;copy tempstr to edi based on _*
  push esi
  mov esi,offset tempstr
  .if (!_pos) && (bptr[esi]=='+') && (_mod=='S')
    mov _mod,0
    inc esi  ;skip the +
  .endif
  .if !_zero  ;remove zero's
    .if _mod=='S'
      mov bl,[esi]  ;save sign
      inc esi ;skip the minus or plus
    .endif
@@:
    cmp bptr[esi],'0'
    jnz @f
    inc esi
    cmp bptr[esi+1],0
    jz @f  ;if all 0s
    jmp @b
@@:
    .if _mod=='S'
      dec esi
      mov [esi],bl
    .endif
  .endif
  callp strlen,esi
  mov ebx,eax
  .if eax < _width
    mov ecx,_width
    sub ecx,eax
    .if _zero
      mov al,'0'
    .else
      mov al,32
    .endif
    rep stosb
  .endif
  mov ecx,ebx
  rep movsb
  pop esi
  jmp @@top
_sprintf_ endp

end

